//go:build windows

package yu_clipboard

import (
	yu_win "gogs.qqck.cn/s/go-tools/win"
)

func Get() string {
	if !yu_win.IsClipboardFormatAvailable.CallBool(yu_win.CF_UNICODETEXT) {
		return ""
	}
	if !yu_win.OpenClipboard.CallBool(0) {
		return ""
	}
	defer yu_win.CloseClipboard.Call()
	return yu_win.GetClipboardData.CallUnicodeToUtf8(yu_win.CF_UNICODETEXT)
	// j_hdata := yu_win.GetClipboardData.CallUintptr(yu_win.CF_UNICODETEXT)
	// if j_hdata == 0 {
	// 	return ""
	// }
	// j_data_ptr := yu_win.GlobalLock.CallUintptr(j_hdata)
	// if j_data_ptr == 0 {
	// 	return ""
	// }
	// defer yu_win.GlobalUnlock.Call(j_data_ptr)
	// return yu_strings.UnicodePtrToUtf8(j_data_ptr)
}

func Set(s string) bool {
	if !yu_win.OpenClipboard.CallBool(0) {
		return false
	}
	defer yu_win.CloseClipboard.Call()
	if !yu_win.EmptyClipboard.CallBool() {
		return false
	}
	if s == "" {
		return true
	}

	j_unicode_size, _, _ := yu_win.MultiByteToWideChar.Call(65001, 0, s, len(s), 0, 0)
	if j_unicode_size < 1 {
		return false
	}
	j_unicode_size = j_unicode_size*2 + 2

	j_hdata, _, _ := yu_win.GlobalAlloc.Call(yu_win.GMEM_MOVEABLE, j_unicode_size)
	if j_hdata == 0 {
		return false
	}
	defer yu_win.GlobalFree.Call(j_hdata)

	j_data_ptr, _, _ := yu_win.GlobalLock.Call(j_hdata)
	if j_data_ptr == 0 {
		return false
	}
	defer yu_win.GlobalUnlock.Call(j_data_ptr)

	yu_win.MultiByteToWideChar.Call(65001, 0, s, len(s), j_data_ptr, j_unicode_size)

	return yu_win.SetClipboardData.CallUintptr(yu_win.CF_UNICODETEXT, j_hdata) != 0
}
