//go:build windows

package yu_dns

import (
	yu_math "gogs.qqck.cn/s/go-tools/math"
	yu_strconv "gogs.qqck.cn/s/go-tools/strconv"
	yu_win "gogs.qqck.cn/s/go-tools/win"
	"unsafe"
)

func ResolveIPB(host string) (ips [][]byte, ipv6 bool) {
	j_data, _, _ := yu_win.Gethostbyname.Call(host + "\x00")
	if j_data == 0 {
		return
	}
	j_hostent := (*yu_win.Hostent)(unsafe.Pointer(j_data))
	switch j_hostent.Length {
	case 4: // ipv4
		var j_add uintptr = 4
		if yu_math.IntSize == 64 {
			j_add = 8
		}
		for ; ; j_hostent.AddrList += j_add {
			j_ipv4 := (**[4]byte)(unsafe.Pointer(j_hostent.AddrList))
			if *j_ipv4 == nil {
				return
			}
			ips = append(ips, (*j_ipv4)[:])
		}
	case 8:
		panic("暂不支持解析IPV6")
	}
	return
}

func ResolveIPS(host string) (ips []string, ipv6 bool) {
	j_ips, j_ipv6 := ResolveIPB(host)
	ipv6 = j_ipv6
	if j_ipv6 {
		panic("暂不支持解析IPV6")
	} else {
		for j_i := 0; j_i < len(j_ips); j_i++ {
			ips = append(ips, yu_strconv.FormatByte(j_ips[j_i][0])+"."+
				yu_strconv.FormatByte(j_ips[j_i][1])+"."+
				yu_strconv.FormatByte(j_ips[j_i][2])+"."+
				yu_strconv.FormatByte(j_ips[j_i][3]),
			)
		}
	}
	return
}
