//go:build windows

package yu_hpsocket

import (
	yu_win "gogs.qqck.cn/s/go-tools/win"
	"unsafe"
)

func socket_isRead(fd uintptr, sec, usec int32) bool {
	switch yu_win.Select.CallInt32(0, unsafe.Pointer(&yu_win.FDSET{1, fd}), 0, 0, unsafe.Pointer(&yu_win.TIMEVAL{sec, usec})) {
	case -1:
		return false // ErrClose
	case 0:
		return false // ErrTimeout
	case 1:
		return true
	default:
		return false // ErrNot
	}
}

func socket_isWrite(fd uintptr, sec, usec int32) bool {
	switch yu_win.Select.CallInt32(0, 0, unsafe.Pointer(&yu_win.FDSET{1, fd}), 0, unsafe.Pointer(&yu_win.TIMEVAL{sec, usec})) {
	case -1:
		return false // ErrClose
	case 0:
		return false // ErrTimeout
	case 1:
		return true
	default:
		return false // ErrNot
	}
}

const _send_size_max = 1024 * 1024 * 32 // 32 MB

func socket_write(fd uintptr, buf []byte) bool {
	if len(buf) == 0 {
		return true
	}
	j_buf_ptr, j_buf_len, j_move := uintptr(unsafe.Pointer(&buf[0])), uintptr(len(buf)), uintptr(0)
	for j_buf_len > 0 {
		if !socket_isWrite(fd, 30, 0) {
			return false
		}
		if j_buf_len > _send_size_max {
			j_move, _, _ = yu_win.Send.Call(fd, j_buf_ptr, _send_size_max, 0)
		} else {
			j_move, _, _ = yu_win.Send.Call(fd, j_buf_ptr, j_buf_len, 0)
		}
		if int32(j_move) < 0 {
			return false
		}
		j_buf_ptr += j_move
		j_buf_len -= j_move
	}
	return true
}

func socket_read(fd uintptr, buf *[]byte) bool {
	if len(*buf) == 0 {
		return false
	}
	if !socket_isRead(fd, 30, 0) {
		return false
	}
	var j_size uintptr
	j_size, _, _ = yu_win.Recv.Call(fd, *buf, len(*buf), 0)
	if int32(j_size) < 1 {
		return false
	}
	*buf = (*buf)[:j_size]
	return true
}
