package yu_pack

// Write appends the contents of p to b's buffer.
// Write always returns len(p), nil.
func (t *Pack) Write(val []byte) (int, error) {
	t.Grow(len(val))
	t.buf = append(t.buf, val...)
	return len(val), nil
}

// WriteByte appends the byte c to b's buffer.
// The returned error is always nil.
func (t *Pack) WriteByte(val byte) error {
	t.Grow(1)
	t.buf = append(t.buf, val)
	return nil
}

// WriteString appends the contents of s to b's buffer.
// It returns the length of s and a nil error.
func (t *Pack) WriteString(val string) (int, error) {
	t.Grow(len(val))
	t.buf = append(t.buf, val...)
	return len(val), nil
}
