package yu_pack

import "io"

// Read implements the io.Reader interface.
func (t *Pack) Read(buf []byte) (n int, err error) {
	if t.get_i >= len(t.buf) {
		return 0, io.EOF
	}
	n = copy(buf, t.buf[t.get_i:])
	t.get_i += n
	return
}

// ReadByte implements the io.ByteReader interface.
func (t *Pack) ReadByte() (val byte, err error) {
	if t.get_i >= len(t.buf) {
		err = io.EOF
		return
	}
	val = t.buf[t.get_i]
	t.get_i++
	return
}
