package yu_rand

import (
	yu_const "gogs.qqck.cn/s/go-tools/const"
)

// Mac
//
//	@Description: 随机生成小写 mac (53:31:32:41:c3:dd)
func Mac() string {
	j_mac := make([]byte, 17)
	Rand.ReadEx(j_mac, yu_const.HexLowerBytes)
	j_mac[2], j_mac[5], j_mac[8], j_mac[11], j_mac[14] = ':', ':', ':', ':', ':'
	return string(j_mac)
}

// MAC
//
//	@Description: 随机生成大写 mac (BF:49:00:F6:DB:8E)
func MAC() string {
	j_mac := make([]byte, 17)
	Rand.ReadEx(j_mac, yu_const.HexUpperBytes)
	j_mac[2], j_mac[5], j_mac[8], j_mac[11], j_mac[14] = ':', ':', ':', ':', ':'
	return string(j_mac)
}

// AndroidId
//
//	@Description: 随机生成小写 AndroidId (20f6e8a69f30aebb)
func AndroidId() string {
	j_mac := make([]byte, 16)
	Rand.ReadEx(j_mac, yu_const.HexLowerBytes)
	return string(j_mac)
}

// AndroidID
//
//	@Description: 随机生成大写 AndroidId (5D2D187C36CD84E4)
func AndroidID() string {
	j_mac := make([]byte, 16)
	Rand.ReadEx(j_mac, yu_const.HexUpperBytes)
	return string(j_mac)
}

// AndroidId
//
//	@Description: 随机生成 Imei
func Imei() string {
	j_sum := 0 // the control j_sum of digits
	j_final := make([]byte, 15)
	for j_i := 0; j_i < 14; j_i++ { // generating all the base digits
		j_toAdd := Intn(10)
		j_final[j_i] = yu_const.HexLower[j_toAdd]
		if (j_i+1)%2 == 0 { // special proc for every 2nd one
			j_toAdd *= 2
			if j_toAdd >= 10 {
				j_toAdd = (j_toAdd % 10) + 1
			}
		}
		j_sum += j_toAdd // and even add them here!
	}
	j_final[14] = yu_const.HexLower[(j_sum*9)%10] // calculating the control digit
	return string(j_final)
}

// Pass
//
//	@Description: 根据规则生成指定长度的密码
//	 a|A=0-9        b|B=a-z        c|C=A-Z        d|D=a-Z
//	 e|E=0-9-a-z    f|F=0-9-A-Z    g|G=0-9-a-Z
//	 h|H=【`~!@#$%^&*()-_=+[{]}\|;:'",<.>/?】
//	 i|I=0-9-a-Z-【`~!@#$%^&*()-_=+[{]}\|;:'",<.>/?】
//
//	 指令前面可带长度指令，长度指令应在 1-9 范围内，不带长度指令则默认为 1，如：
//	 [1]a 表示 1 个随机 a 指令；
//	 [3]a 表示 3 个随机 a 指令；
//	 [2-5]a 表示随机 2-5 个随机 a 指令
//
//	 "hh" 表示插入 hh 字符
//
//	 示例：aAbB[2]C[1-3]H 或 aAbB [2]C [1-3]H 可能会生成：
//	 16akYU@
//	 27fdAS@!
//	 63isSY%&~
//
//	 示例：a"nihao"AbB[2]C[1-3]H 或 "nihao"aAbB [2]C [1-3]H 可能会生成：
//	 1nihao6akYU@
//	 nihao27fdAS@!
//	 6nihao3isSY%&~
func Pass(rule string) string {
	j_buf := make([]byte, 0, len(rule)*9)
	j_len_min, j_len_max := int32(1), int32(1)
	j_lens, j_len_, j_lene, j_append := false, false, false, false
	for _, j_ascii := range rule {
		if j_ascii == '"' {
			j_append = !j_append
			continue
		}
		if j_append {
			j_buf = append(j_buf, byte(j_ascii))
			continue
		}
		switch j_ascii {
		case '[':
			j_lens = true
		case '1':
			// 默认就是 1
		case '2':
			if j_len_ {
				j_len_max = 2
			} else {
				j_len_min = 2
			}
		case '3':
			if j_len_ {
				j_len_max = 3
			} else {
				j_len_min = 3
			}
		case '4':
			if j_len_ {
				j_len_max = 4
			} else {
				j_len_min = 4
			}
		case '5':
			if j_len_ {
				j_len_max = 5
			} else {
				j_len_min = 5
			}
		case '6':
			if j_len_ {
				j_len_max = 6
			} else {
				j_len_min = 6
			}
		case '7':
			if j_len_ {
				j_len_max = 7
			} else {
				j_len_min = 7
			}
		case '8':
			if j_len_ {
				j_len_max = 8
			} else {
				j_len_min = 8
			}
		case '9':
			if j_len_ {
				j_len_max = 9
			} else {
				j_len_min = 9
			}
		case '-':
			j_len_ = true
		case ']':
			j_lene = true
		case 'a', 'A', 'b', 'B', 'c', 'C', 'd', 'D', 'e', 'E', 'f', 'F', 'g', 'G', 'h', 'H', 'i', 'I':
			j_len := 1
			if j_lens && j_lene {
				if j_len_ && j_len_min != j_len_max {
					if j_len_min < j_len_max {
						j_len = int(Int31MinMax(j_len_min, j_len_max))
					} else {
						j_len = int(Int31MinMax(j_len_max, j_len_min))
					}
				} else {
					j_len = int(j_len_min)
				}
			}
			j_len_min, j_len_max = 1, 1                  // 复位
			j_lens, j_len_, j_lene = false, false, false // 复位
			switch j_ascii {
			case 'a', 'A':
				for ; j_len > 0; j_len-- {
					j_buf = append(j_buf, byte(Int31n(10))+'0')
				}
			case 'b', 'B':
				for ; j_len > 0; j_len-- {
					j_buf = append(j_buf, byte(Int31n(26))+'a')
				}
			case 'c', 'C':
				for ; j_len > 0; j_len-- {
					j_buf = append(j_buf, byte(Int31n(26))+'A')
				}
			case 'd', 'D':
				for ; j_len > 0; j_len-- {
					if Int31n(2) == 0 {
						j_buf = append(j_buf, byte(Int31n(26))+'a')
					} else {
						j_buf = append(j_buf, byte(Int31n(26))+'A')
					}
				}
			case 'e', 'E':
				for ; j_len > 0; j_len-- {
					if Int31n(2) == 0 {
						j_buf = append(j_buf, byte(Int31n(10))+'0')
					} else {
						j_buf = append(j_buf, byte(Int31n(26))+'a')
					}
				}
			case 'f', 'F':
				for ; j_len > 0; j_len-- {
					if Int31n(2) == 0 {
						j_buf = append(j_buf, byte(Int31n(10))+'0')
					} else {
						j_buf = append(j_buf, byte(Int31n(26))+'A')
					}
				}
			case 'g', 'G':
				for ; j_len > 0; j_len-- {
					switch Int31n(3) {
					case 0:
						j_buf = append(j_buf, byte(Int31n(10))+'0')
					case 1:
						j_buf = append(j_buf, byte(Int31n(26))+'a')
					default:
						j_buf = append(j_buf, byte(Int31n(26))+'A')
					}
				}
			case 'h', 'H':
				for ; j_len > 0; j_len-- {
					j_buf = append(j_buf, str_other[Int31n(str_other_len)])
				}
			case 'i', 'I':
				for ; j_len > 0; j_len-- {
					j_buf = append(j_buf, byte(Int31n(94))+33) // 33 - 126
				}
			}
		}
	}
	return string(j_buf)
}
